# 4.1.0

Release date: `2019-03-26`

## Core

- [NXDRIVE-1109](https://jira.nuxeo.com/browse/NXDRIVE-1109): Use the pathlib module to handle paths
- [NXDRIVE-1221](https://jira.nuxeo.com/browse/NXDRIVE-1221): Fix thread leak
- [NXDRIVE-1467](https://jira.nuxeo.com/browse/NXDRIVE-1467): Implement FS decorator on Windows
- [NXDRIVE-1468](https://jira.nuxeo.com/browse/NXDRIVE-1468): Factorize FS decoration handling cross-platform
- [NXDRIVE-1469](https://jira.nuxeo.com/browse/NXDRIVE-1469): Display a message on forbidden DriveEdit action
- [NXDRIVE-1475](https://jira.nuxeo.com/browse/NXDRIVE-1475): Use Sentry to share logs
- [NXDRIVE-1483](https://jira.nuxeo.com/browse/NXDRIVE-1483): Ensure extensions are closed before upgrading
- [NXDRIVE-1484](https://jira.nuxeo.com/browse/NXDRIVE-1484): Backup databases before exiting
- [NXDRIVE-1492](https://jira.nuxeo.com/browse/NXDRIVE-1492): Access to the local socket is denied
- [NXDRIVE-1493](https://jira.nuxeo.com/browse/NXDRIVE-1493): Add DirectEdit support for the Adobe Creative Suite
- [NXDRIVE-1494](https://jira.nuxeo.com/browse/NXDRIVE-1494): Introduce specific getters and setters for database
- [NXDRIVE-1497](https://jira.nuxeo.com/browse/NXDRIVE-1497): Fix alert when a server is not responding
- [NXDRIVE-1501](https://jira.nuxeo.com/browse/NXDRIVE-1501): Prompt for confirmation when a user deletes a document locally
- [NXDRIVE-1510](https://jira.nuxeo.com/browse/NXDRIVE-1510): Handle `PermissionError` in `get_open_files()`
- [NXDRIVE-1511](https://jira.nuxeo.com/browse/NXDRIVE-1511): Fix pair state for 'unsynchronized' and 'synchronized'
- [NXDRIVE-1517](https://jira.nuxeo.com/browse/NXDRIVE-1517): Ensure remote ref is always set
- [NXDRIVE-1518](https://jira.nuxeo.com/browse/NXDRIVE-1518): Fix watchdog observer `stop()` call
- [NXDRIVE-1519](https://jira.nuxeo.com/browse/NXDRIVE-1519): Allow DirectEdit'ing documents with the Folderish facet
- [NXDRIVE-1520](https://jira.nuxeo.com/browse/NXDRIVE-1520): Always send statistics, even if there is no engine
- [NXDRIVE-1523](https://jira.nuxeo.com/browse/NXDRIVE-1523): (GNU/Linux) Handle paths with more than 143 chars on encrypted FS
- [NXDRIVE-1529](https://jira.nuxeo.com/browse/NXDRIVE-1529): Review behavior of Windows registry functions
- [NXDRIVE-1530](https://jira.nuxeo.com/browse/NXDRIVE-1530): Handle `PermissionError` when trashing documents
- [NXDRIVE-1531](https://jira.nuxeo.com/browse/NXDRIVE-1531): Fix QThread exception on exit
- [NXDRIVE-1534](https://jira.nuxeo.com/browse/NXDRIVE-1534): Do not consider HTTP timeouts as errors in the Remote Watcher
- [NXDRIVE-1535](https://jira.nuxeo.com/browse/NXDRIVE-1535): Handle `Unauthorized` errors from the Processor
- [NXDRIVE-1537](https://jira.nuxeo.com/browse/NXDRIVE-1537): Prompt the user for metrics sharing settings
- [NXDRIVE-1540](https://jira.nuxeo.com/browse/NXDRIVE-1540): Avoid renaming banned files
- [NXDRIVE-1543](https://jira.nuxeo.com/browse/NXDRIVE-1543): Make `LocalClient.exists()` return False on any `OSError`
- [NXDRIVE-1545](https://jira.nuxeo.com/browse/NXDRIVE-1545): Avoid sending `NotFound` exceptions to Sentry
- [NXDRIVE-1549](https://jira.nuxeo.com/browse/NXDRIVE-1549): Fix DirectEdit unlock issue with missing Engine
- [NXDRIVE-1550](https://jira.nuxeo.com/browse/NXDRIVE-1550): Allow DirectEdit on custom xpath
- [NXDRIVE-1553](https://jira.nuxeo.com/browse/NXDRIVE-1553): Check the uuid of a document before trashing it
- [NXDRIVE-1555](https://jira.nuxeo.com/browse/NXDRIVE-1555): Handle bad remote changes values
- [NXDRIVE-1556](https://jira.nuxeo.com/browse/NXDRIVE-1556): Display a warning when activating DEBUG logs about sensitive data
- [NXDRIVE-1559](https://jira.nuxeo.com/browse/NXDRIVE-1559): Use separate prompts for downgrade in cases of incompatibility or wrong channel
- [NXDRIVE-1561](https://jira.nuxeo.com/browse/NXDRIVE-1561): Display the fatal error screen only when necessary
- [NXDRIVE-1562](https://jira.nuxeo.com/browse/NXDRIVE-1562): Handle `MemoryError` in `get_open_files()`
- [NXDRIVE-1563](https://jira.nuxeo.com/browse/NXDRIVE-1563): (macOS) Prevent user from running the app from a modified path and inform them
- [NXDRIVE-1567](https://jira.nuxeo.com/browse/NXDRIVE-1567): Use UTF-8 as encoding when dumping a database
- [NXDRIVE-1568](https://jira.nuxeo.com/browse/NXDRIVE-1568): Fix authentication expired notification
- [NXDRIVE-1569](https://jira.nuxeo.com/browse/NXDRIVE-1569): Ignore Adobe InDesign lock files
- [NXDRIVE-1587](https://jira.nuxeo.com/browse/NXDRIVE-1587): Do not call `Manager.stop()` when the server is not compatible
- [NXDRIVE-1588](https://jira.nuxeo.com/browse/NXDRIVE-1588): Fix folders watch on Windows
- [NXDRIVE-1595](https://jira.nuxeo.com/browse/NXDRIVE-1595): Fix malformed SSL certificate retrieving
- [NXDRIVE-1598](https://jira.nuxeo.com/browse/NXDRIVE-1598): Ensure the `QLocalSocket` is connected before disconnection

## GUI

- [NXDRIVE-1489](https://jira.nuxeo.com/browse/NXDRIVE-1489): Fix Resolution options display
- [NXDRIVE-1527](https://jira.nuxeo.com/browse/NXDRIVE-1527): Fix error display with long document title
- [NXDRIVE-1528](https://jira.nuxeo.com/browse/NXDRIVE-1528): Allow errors window to be resized
- [NXDRIVE-1551](https://jira.nuxeo.com/browse/NXDRIVE-1551): Fix systray display on Windows 10

## Packaging / Build

- [NXDRIVE-1521](https://jira.nuxeo.com/browse/NXDRIVE-1521): Stick with pip 18.1
- [NXDRIVE-1532](https://jira.nuxeo.com/browse/NXDRIVE-1532): Fix several pyenv issues

## Doc

- [NXDRIVE-1522](https://jira.nuxeo.com/browse/NXDRIVE-1522): Introduce DEPs :book:

## Tests

- [NXDRIVE-818](https://jira.nuxeo.com/browse/NXDRIVE-818): Fix `test_synchronize_no_space_left_on_device()`
- [NXDRIVE-1390](https://jira.nuxeo.com/browse/NXDRIVE-1390): Fix pytest 3.9 warnings that break tests
- [NXDRIVE-1436](https://jira.nuxeo.com/browse/NXDRIVE-1436): Split test files to speed-up overall testing time
- [NXDRIVE-1503](https://jira.nuxeo.com/browse/NXDRIVE-1503): Fix `test_collection.py` when it fails early
- [NXDRIVE-1510](https://jira.nuxeo.com/browse/NXDRIVE-1510): Unskip `test_move_untrash_file_on_parent_with_no_rights()` since [NXP-25066](https://jira.nuxeo.com/browse/NXP-25066) has been resolved sometime ago
- [NXDRIVE-1536](https://jira.nuxeo.com/browse/NXDRIVE-1536): Use mock'ed objects instead of manual swap
- [NXDRIVE-1542](https://jira.nuxeo.com/browse/NXDRIVE-1542): Unlock tests parallelization!
- [NXDRIVE-1546](https://jira.nuxeo.com/browse/NXDRIVE-1546): Filter out `KeyboardInterrupt` errors from Sentry events

## Minor Changes

- Logging: The `TRACE` level has been removed
- Packaging: Added `faker` 1.0.4
- Packaging: Added `pyobjc-framework-ScriptingBridge` 4.2.2
- Packaging: Added `PyQt5-sip` 4.19.13
- Packaging: Added `pytest-xdist` 1.26.1
- Packaging: Added `sentry-sdk` 0.7.3
- Packaging: Updated `distro` from 1.3.0 to 1.4.0
- Packaging: Updated `flake8` from 3.6.0 to 3.7.7
- Packaging: Updated `mypy` from 0.650 to 0.670
- Packaging: Updated `pre-commit` from 1.13.0 to 1.14.4
- Packaging: Updated `psutils` from 5.4.8 to 5.6.1
- Packaging: Updated `pycryptodomex` from 3.7.2 to 3.7.3
- Packaging: Updated `pytest` from 3.8.2 to 4.3.1
- Packaging: Updated `python-dateutil` from 2.7.5 to 2.8.0
- Testing: The `SENTRY_ENV` envar is now mandatory

## Technical Changes

- Changed type of all local paths from `str` to pathlib `Path`
- Added `AbstractOSIntegration.addons_installed()`
- Added `AbstractOSIntegration.get_extension_listener()`
- Added `AbstractOSIntegration.install_addons()`
- Removed `name` keyword argument from `AbstractOSIntegration.register_folder_link()`
- Added `Application.confirm_deletion()`
- Added `BaseUpdater.get_version_channel()`
- Added `ConfigurationDAO.get_bool()`
- Added `ConfigurationDAO.get_int()`
- Added `ConfigurationDAO.store_bool()`
- Added `ConfigurationDAO.store_int()`
- Added `DarwinIntegration.get_extension_listener()`
- Added `DarwinIntegration.open_local_file()`
- Added `Engine.delete_doc()`
- Added `Engine.docDeleted`
- Added `Engine.rollback_delete()`
- Removed `Engine.fileDeletionErrorTooLong`. Use `longPathError` instead.
- Removed `Engine.local_folder_bs`
- Added `EngineDAO.force_remote_creation()`
- Added `EngineDAO.remove_state_children()`
- Removed `LocalClient.get_children_ref()`
- Added `Manager.get_deletion_behavior()`
- Added `Manager.get_log_level()`
- Added `Manager.set_deletion_behavior()`
- Added `Manager.set_log_level()`
- Added `Manager.restart_needed`
- Renamed `Manager.nxdrive_home` to `home`
- Removed `Manager.get()`
- Removed `Manager.set_tracking()`
- Added `NuxeoDocumentInfo.get_blob()`
- Added `QMLDriveApi.get_deletion_behavior()`
- Added `QMLDriveApi.get_log_level()`
- Added `QMLDriveApi.restart_needed()`
- Added `QMLDriveApi.set_deletion_behavior()`
- Added `QMLDriveApi.set_log_level()`
- Removed `QMLDriveApi.get_tracking()`
- Removed `QMLDriveApi.set_tracking()`
- Added `Remote.execute()`
- Added `WindowsIntegration.addons_installed()`
- Added `WindowsIntegration.get_extension_listener()`
- Added `WindowsIntegration.install_addons()`
- Added `WindowsIntegration.open_local_file()`
- Added `WindowsIntegration.send_sync_status()`
- Added `WindowsIntegration.unwatch_folder()`
- Added `WindowsIntegration.watch_folder()`
- Removed `Worker.get_thread()`. Use `thread` attribute instead.
- Removed `Worker.get_thread_id()`. Use `thread_id` attribute instead.
- Added constants.py::`COMPANY`
- Added constants.py::`DelAction`
- Added engine/dao/sqlite.py::`prepare_args()`
- Added engine/dao/sqlite.py::`str_to_path()`
- Added exceptions.py::`Forbidden`
- Moved autolocker.py::`Item` to objects.py
- Moved autolocker.py::`Items` to objects.py
- Removed notifications.py::`FileDeletionError`. Use `LongPathError` instead.
- Added `properties` to objects.py::`NuxeoDocumentInfo`
- Removed `blobs` from objects.py::`NuxeoDocumentInfo` attributes
- Added options.py::`deletion_behavior`
- Added options.py::`use_analytics`
- Added options.py::`use_sentry`
- Changed options_updater.py to poll_workers.py
- Added osi/darwin/extension.py
- Added osi/darwin/files.py
- Removed osi/darwin/darwin.py::`FinderSyncServer`
- Added osi/extension.py
- Added osi/linux
- Added osi/windows/extension.py
- Added osi/windows/files.py
- Added poll_workers.py::`DatabaseBackupWorker`
- Added updater/constants.py::`Login`
- Added updater/utils.py::`get_compatible_versions()`
- Added updater/utils.py::`get_latest_version()`
- Added updater/utils.py::`is_version_compatible()`
- Changed updater/utils.py::`get_update_status()` argument `has_browser_login` (`bool`) to `login_type` (`Login`)
- Removed updater/utils.py::`get_latest_compatible_version()`
- Added utils.py::`compute_fake_pid_from_path()`
- Removed utils.py::`path_join()`
